diff --git a/django/conf/locale/nb/formats.py b/django/conf/locale/nb/formats.py
index fbc6142..996eb5a 100644
--- a/django/conf/locale/nb/formats.py
+++ b/django/conf/locale/nb/formats.py
@@ -7,11 +7,11 @@ SHORT_DATE_FORMAT = 'd.m.Y'
 SHORT_DATETIME_FORMAT = 'd.m.Y H:i'
 FIRST_DAY_OF_WEEK = 1 # Monday
 DATE_INPUT_FORMATS = (
-    '%Y-%m-%d', '%j.%m.%Y', '%j.%m.%y', # '2006-10-25', '25.10.2006', '25.10.06'
-    '%Y-%m-%j',                         # '2006-10-25',
-    # '%j. %b %Y', '%j %b %Y',            # '25. okt 2006', '25 okt 2006'
-    # '%j. %b. %Y', '%j %b. %Y',          # '25. okt. 2006', '25 okt. 2006'
-    # '%j. %B %Y', '%j %B %Y',            # '25. oktober 2006', '25 oktober 2006'
+    '%Y-%m-%d', '%d.%m.%Y', '%d.%m.%y', # '2006-10-25', '25.10.2006', '25.10.06'
+    '%Y-%m-%d',                         # '2006-10-25',
+    # '%d. %b %Y', '%d %b %Y',            # '25. okt 2006', '25 okt 2006'
+    # '%d. %b. %Y', '%d %b. %Y',          # '25. okt. 2006', '25 okt. 2006'
+    # '%d. %B %Y', '%d %B %Y',            # '25. oktober 2006', '25 oktober 2006'
 )
 TIME_INPUT_FORMATS = (
     '%H:%M:%S',     # '14:30:59'
@@ -21,13 +21,13 @@ DATETIME_INPUT_FORMATS = (
     '%Y-%m-%d %H:%M:%S',     # '2006-10-25 14:30:59'
     '%Y-%m-%d %H:%M',        # '2006-10-25 14:30'
     '%Y-%m-%d',              # '2006-10-25'
-    '%Y-%m-%j',              # '2006-10-25'
-    '%j.%m.%Y %H:%M:%S',     # '25.10.2006 14:30:59'
-    '%j.%m.%Y %H:%M',        # '25.10.2006 14:30'
-    '%j.%m.%Y',              # '25.10.2006'
-    '%j.%m.%y %H:%M:%S',     # '25.10.06 14:30:59'
-    '%j.%m.%y %H:%M',        # '25.10.06 14:30'
-    '%j.%m.%y',              # '25.10.06'
+    '%Y-%m-%d',              # '2006-10-25'
+    '%d.%m.%Y %H:%M:%S',     # '25.10.2006 14:30:59'
+    '%d.%m.%Y %H:%M',        # '25.10.2006 14:30'
+    '%d.%m.%Y',              # '25.10.2006'
+    '%d.%m.%y %H:%M:%S',     # '25.10.06 14:30:59'
+    '%d.%m.%y %H:%M',        # '25.10.06 14:30'
+    '%d.%m.%y',              # '25.10.06'
 )
 DECIMAL_SEPARATOR = ','
 THOUSAND_SEPARATOR = ' '
diff --git a/django/conf/locale/nn/formats.py b/django/conf/locale/nn/formats.py
index fbc6142..996eb5a 100644
--- a/django/conf/locale/nn/formats.py
+++ b/django/conf/locale/nn/formats.py
@@ -7,11 +7,11 @@ SHORT_DATE_FORMAT = 'd.m.Y'
 SHORT_DATETIME_FORMAT = 'd.m.Y H:i'
 FIRST_DAY_OF_WEEK = 1 # Monday
 DATE_INPUT_FORMATS = (
-    '%Y-%m-%d', '%j.%m.%Y', '%j.%m.%y', # '2006-10-25', '25.10.2006', '25.10.06'
-    '%Y-%m-%j',                         # '2006-10-25',
-    # '%j. %b %Y', '%j %b %Y',            # '25. okt 2006', '25 okt 2006'
-    # '%j. %b. %Y', '%j %b. %Y',          # '25. okt. 2006', '25 okt. 2006'
-    # '%j. %B %Y', '%j %B %Y',            # '25. oktober 2006', '25 oktober 2006'
+    '%Y-%m-%d', '%d.%m.%Y', '%d.%m.%y', # '2006-10-25', '25.10.2006', '25.10.06'
+    '%Y-%m-%d',                         # '2006-10-25',
+    # '%d. %b %Y', '%d %b %Y',            # '25. okt 2006', '25 okt 2006'
+    # '%d. %b. %Y', '%d %b. %Y',          # '25. okt. 2006', '25 okt. 2006'
+    # '%d. %B %Y', '%d %B %Y',            # '25. oktober 2006', '25 oktober 2006'
 )
 TIME_INPUT_FORMATS = (
     '%H:%M:%S',     # '14:30:59'
@@ -21,13 +21,13 @@ DATETIME_INPUT_FORMATS = (
     '%Y-%m-%d %H:%M:%S',     # '2006-10-25 14:30:59'
     '%Y-%m-%d %H:%M',        # '2006-10-25 14:30'
     '%Y-%m-%d',              # '2006-10-25'
-    '%Y-%m-%j',              # '2006-10-25'
-    '%j.%m.%Y %H:%M:%S',     # '25.10.2006 14:30:59'
-    '%j.%m.%Y %H:%M',        # '25.10.2006 14:30'
-    '%j.%m.%Y',              # '25.10.2006'
-    '%j.%m.%y %H:%M:%S',     # '25.10.06 14:30:59'
-    '%j.%m.%y %H:%M',        # '25.10.06 14:30'
-    '%j.%m.%y',              # '25.10.06'
+    '%Y-%m-%d',              # '2006-10-25'
+    '%d.%m.%Y %H:%M:%S',     # '25.10.2006 14:30:59'
+    '%d.%m.%Y %H:%M',        # '25.10.2006 14:30'
+    '%d.%m.%Y',              # '25.10.2006'
+    '%d.%m.%y %H:%M:%S',     # '25.10.06 14:30:59'
+    '%d.%m.%y %H:%M',        # '25.10.06 14:30'
+    '%d.%m.%y',              # '25.10.06'
 )
 DECIMAL_SEPARATOR = ','
 THOUSAND_SEPARATOR = ' '
diff --git a/django/conf/locale/no/formats.py b/django/conf/locale/no/formats.py
index fbc6142..996eb5a 100644
--- a/django/conf/locale/no/formats.py
+++ b/django/conf/locale/no/formats.py
@@ -7,11 +7,11 @@ SHORT_DATE_FORMAT = 'd.m.Y'
 SHORT_DATETIME_FORMAT = 'd.m.Y H:i'
 FIRST_DAY_OF_WEEK = 1 # Monday
 DATE_INPUT_FORMATS = (
-    '%Y-%m-%d', '%j.%m.%Y', '%j.%m.%y', # '2006-10-25', '25.10.2006', '25.10.06'
-    '%Y-%m-%j',                         # '2006-10-25',
-    # '%j. %b %Y', '%j %b %Y',            # '25. okt 2006', '25 okt 2006'
-    # '%j. %b. %Y', '%j %b. %Y',          # '25. okt. 2006', '25 okt. 2006'
-    # '%j. %B %Y', '%j %B %Y',            # '25. oktober 2006', '25 oktober 2006'
+    '%Y-%m-%d', '%d.%m.%Y', '%d.%m.%y', # '2006-10-25', '25.10.2006', '25.10.06'
+    '%Y-%m-%d',                         # '2006-10-25',
+    # '%d. %b %Y', '%d %b %Y',            # '25. okt 2006', '25 okt 2006'
+    # '%d. %b. %Y', '%d %b. %Y',          # '25. okt. 2006', '25 okt. 2006'
+    # '%d. %B %Y', '%d %B %Y',            # '25. oktober 2006', '25 oktober 2006'
 )
 TIME_INPUT_FORMATS = (
     '%H:%M:%S',     # '14:30:59'
@@ -21,13 +21,13 @@ DATETIME_INPUT_FORMATS = (
     '%Y-%m-%d %H:%M:%S',     # '2006-10-25 14:30:59'
     '%Y-%m-%d %H:%M',        # '2006-10-25 14:30'
     '%Y-%m-%d',              # '2006-10-25'
-    '%Y-%m-%j',              # '2006-10-25'
-    '%j.%m.%Y %H:%M:%S',     # '25.10.2006 14:30:59'
-    '%j.%m.%Y %H:%M',        # '25.10.2006 14:30'
-    '%j.%m.%Y',              # '25.10.2006'
-    '%j.%m.%y %H:%M:%S',     # '25.10.06 14:30:59'
-    '%j.%m.%y %H:%M',        # '25.10.06 14:30'
-    '%j.%m.%y',              # '25.10.06'
+    '%Y-%m-%d',              # '2006-10-25'
+    '%d.%m.%Y %H:%M:%S',     # '25.10.2006 14:30:59'
+    '%d.%m.%Y %H:%M',        # '25.10.2006 14:30'
+    '%d.%m.%Y',              # '25.10.2006'
+    '%d.%m.%y %H:%M:%S',     # '25.10.06 14:30:59'
+    '%d.%m.%y %H:%M',        # '25.10.06 14:30'
+    '%d.%m.%y',              # '25.10.06'
 )
 DECIMAL_SEPARATOR = ','
 THOUSAND_SEPARATOR = ' '