diff --git a/tests/modeltests/test_client/urls.py b/tests/modeltests/test_client/urls.py
index 9e0eabe..c2e7d15 100644
--- a/tests/modeltests/test_client/urls.py
+++ b/tests/modeltests/test_client/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns
 from django.views.generic.simple import redirect_to
 import views
 
diff --git a/tests/regressiontests/admin_views/urls.py b/tests/regressiontests/admin_views/urls.py
index f3f1fbd..57c157e 100644
--- a/tests/regressiontests/admin_views/urls.py
+++ b/tests/regressiontests/admin_views/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, include
 from django.contrib import admin
 import views
 import customadmin
diff --git a/tests/regressiontests/admin_widgets/urls.py b/tests/regressiontests/admin_widgets/urls.py
index af73d53..2ad23c1 100644
--- a/tests/regressiontests/admin_widgets/urls.py
+++ b/tests/regressiontests/admin_widgets/urls.py
@@ -1,5 +1,4 @@
-
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, include
 import widgetadmin
 
 urlpatterns = patterns('',
diff --git a/tests/regressiontests/comment_tests/urls.py b/tests/regressiontests/comment_tests/urls.py
index 0058689..2a16e05 100644
--- a/tests/regressiontests/comment_tests/urls.py
+++ b/tests/regressiontests/comment_tests/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url
 
 urlpatterns = patterns('regressiontests.comment_tests.custom_comments.views',
     url(r'^post/$',          'custom_submit_comment'),
diff --git a/tests/regressiontests/comment_tests/urls_admin.py b/tests/regressiontests/comment_tests/urls_admin.py
index 341285d..7958fc1 100644
--- a/tests/regressiontests/comment_tests/urls_admin.py
+++ b/tests/regressiontests/comment_tests/urls_admin.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, include
 from django.contrib import admin
 from django.contrib.comments.admin import CommentsAdmin
 from django.contrib.comments.models import Comment
diff --git a/tests/regressiontests/conditional_processing/urls.py b/tests/regressiontests/conditional_processing/urls.py
index 4dbe11a..932f0fe 100644
--- a/tests/regressiontests/conditional_processing/urls.py
+++ b/tests/regressiontests/conditional_processing/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns
 import views
 
 urlpatterns = patterns('',
diff --git a/tests/regressiontests/context_processors/urls.py b/tests/regressiontests/context_processors/urls.py
index 30728c8..21c0c4c 100644
--- a/tests/regressiontests/context_processors/urls.py
+++ b/tests/regressiontests/context_processors/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url
 
 import views
 
diff --git a/tests/regressiontests/file_uploads/urls.py b/tests/regressiontests/file_uploads/urls.py
index 413080e..1880a3b 100644
--- a/tests/regressiontests/file_uploads/urls.py
+++ b/tests/regressiontests/file_uploads/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns
 import views
 
 urlpatterns = patterns('',
diff --git a/tests/regressiontests/formwizard/urls.py b/tests/regressiontests/formwizard/urls.py
index d964bc6..e4e6e4e 100644
--- a/tests/regressiontests/formwizard/urls.py
+++ b/tests/regressiontests/formwizard/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url
 from forms import ContactWizard, Page1, Page2, Page3
 
 urlpatterns = patterns('',
diff --git a/tests/regressiontests/generic_inline_admin/urls.py b/tests/regressiontests/generic_inline_admin/urls.py
index c3e8af8..154e303 100644
--- a/tests/regressiontests/generic_inline_admin/urls.py
+++ b/tests/regressiontests/generic_inline_admin/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, include
 from django.contrib import admin
 
 urlpatterns = patterns('',
diff --git a/tests/regressiontests/generic_views/urls.py b/tests/regressiontests/generic_views/urls.py
index 548d10d..5081943 100644
--- a/tests/regressiontests/generic_views/urls.py
+++ b/tests/regressiontests/generic_views/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url
 from django.views.generic import TemplateView
 
 import views
diff --git a/tests/regressiontests/middleware_exceptions/urls.py b/tests/regressiontests/middleware_exceptions/urls.py
index 5b477a4..2ace688 100644
--- a/tests/regressiontests/middleware_exceptions/urls.py
+++ b/tests/regressiontests/middleware_exceptions/urls.py
@@ -1,5 +1,5 @@
 # coding: utf-8
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns
 
 import views
 
diff --git a/tests/regressiontests/special_headers/urls.py b/tests/regressiontests/special_headers/urls.py
index c6b05d6..4644c69 100644
--- a/tests/regressiontests/special_headers/urls.py
+++ b/tests/regressiontests/special_headers/urls.py
@@ -1,5 +1,5 @@
 # coding: utf-8
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns
 from django.views.generic.list_detail import object_detail
 from models import Article
 import views
diff --git a/tests/regressiontests/staticfiles_tests/urls/default.py b/tests/regressiontests/staticfiles_tests/urls/default.py
index 061ec64..502841b 100644
--- a/tests/regressiontests/staticfiles_tests/urls/default.py
+++ b/tests/regressiontests/staticfiles_tests/urls/default.py
@@ -1,5 +1,5 @@
 from django.conf import settings
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url
 
 urlpatterns = patterns('',
     url(r'^static/(?P<path>.*)$', 'django.contrib.staticfiles.views.serve'),
diff --git a/tests/regressiontests/syndication/urls.py b/tests/regressiontests/syndication/urls.py
index 881fa48..7704078 100644
--- a/tests/regressiontests/syndication/urls.py
+++ b/tests/regressiontests/syndication/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns
 
 import feeds
 
diff --git a/tests/regressiontests/templates/urls.py b/tests/regressiontests/templates/urls.py
index 28d4133..5460f36 100644
--- a/tests/regressiontests/templates/urls.py
+++ b/tests/regressiontests/templates/urls.py
@@ -1,5 +1,5 @@
 # coding: utf-8
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url
 from regressiontests.templates import views
 
 urlpatterns = patterns('',
diff --git a/tests/regressiontests/test_client_regress/urls.py b/tests/regressiontests/test_client_regress/urls.py
index 650d80b..325ef91 100644
--- a/tests/regressiontests/test_client_regress/urls.py
+++ b/tests/regressiontests/test_client_regress/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url
 from django.views.generic.simple import redirect_to
 import views
 
diff --git a/tests/regressiontests/urlpatterns_reverse/extra_urls.py b/tests/regressiontests/urlpatterns_reverse/extra_urls.py
index c171f6d..3a56f2d 100644
--- a/tests/regressiontests/urlpatterns_reverse/extra_urls.py
+++ b/tests/regressiontests/urlpatterns_reverse/extra_urls.py
@@ -2,7 +2,7 @@
 Some extra URL patterns that are included at the top level.
 """
 
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url, include
 from views import empty_view
 
 urlpatterns = patterns('',
diff --git a/tests/regressiontests/urlpatterns_reverse/included_named_urls.py b/tests/regressiontests/urlpatterns_reverse/included_named_urls.py
index b3f7903..aec96c5 100644
--- a/tests/regressiontests/urlpatterns_reverse/included_named_urls.py
+++ b/tests/regressiontests/urlpatterns_reverse/included_named_urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url, include
 from views import empty_view
 
 urlpatterns = patterns('',
diff --git a/tests/regressiontests/urlpatterns_reverse/included_named_urls2.py b/tests/regressiontests/urlpatterns_reverse/included_named_urls2.py
index 96c42c3..65d2178 100644
--- a/tests/regressiontests/urlpatterns_reverse/included_named_urls2.py
+++ b/tests/regressiontests/urlpatterns_reverse/included_named_urls2.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patters, url
 from views import empty_view
 
 urlpatterns = patterns('',
diff --git a/tests/regressiontests/urlpatterns_reverse/included_namespace_urls.py b/tests/regressiontests/urlpatterns_reverse/included_namespace_urls.py
index 16887e2..86c48b5 100644
--- a/tests/regressiontests/urlpatterns_reverse/included_namespace_urls.py
+++ b/tests/regressiontests/urlpatterns_reverse/included_namespace_urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url, include
 from namespace_urls import URLObject
 from views import view_class_instance
 
diff --git a/tests/regressiontests/urlpatterns_reverse/included_urls.py b/tests/regressiontests/urlpatterns_reverse/included_urls.py
index f8acf34..4c5327b 100644
--- a/tests/regressiontests/urlpatterns_reverse/included_urls.py
+++ b/tests/regressiontests/urlpatterns_reverse/included_urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url
 from views import empty_view
 
 urlpatterns = patterns('',
diff --git a/tests/regressiontests/urlpatterns_reverse/included_urls2.py b/tests/regressiontests/urlpatterns_reverse/included_urls2.py
index f414ca6..f130275 100644
--- a/tests/regressiontests/urlpatterns_reverse/included_urls2.py
+++ b/tests/regressiontests/urlpatterns_reverse/included_urls2.py
@@ -5,7 +5,7 @@ each name to resolve and Django must distinguish the possibilities based on the
 argument list.
 """
 
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url
 from views import empty_view
 
 urlpatterns = patterns('',
diff --git a/tests/regressiontests/urlpatterns_reverse/named_urls.py b/tests/regressiontests/urlpatterns_reverse/named_urls.py
index d8a61a1..0ee8c40 100644
--- a/tests/regressiontests/urlpatterns_reverse/named_urls.py
+++ b/tests/regressiontests/urlpatterns_reverse/named_urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url, include
 from views import empty_view
 
 urlpatterns = patterns('',
diff --git a/tests/regressiontests/urlpatterns_reverse/namespace_urls.py b/tests/regressiontests/urlpatterns_reverse/namespace_urls.py
index 3d34049..ed32fcc 100644
--- a/tests/regressiontests/urlpatterns_reverse/namespace_urls.py
+++ b/tests/regressiontests/urlpatterns_reverse/namespace_urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url, include
 from views import view_class_instance
 
 class URLObject(object):
diff --git a/tests/regressiontests/urlpatterns_reverse/no_urls.py b/tests/regressiontests/urlpatterns_reverse/no_urls.py
index c9b9efe..a8fcc4c 100644
--- a/tests/regressiontests/urlpatterns_reverse/no_urls.py
+++ b/tests/regressiontests/urlpatterns_reverse/no_urls.py
@@ -1,2 +1,2 @@
-#from django.conf.urls.defaults import *
+#from django.conf.urls.defaults import patterns, url, include
 
diff --git a/tests/regressiontests/urlpatterns_reverse/urlconf_inner.py b/tests/regressiontests/urlpatterns_reverse/urlconf_inner.py
index d188e06..c9f0e7b 100644
--- a/tests/regressiontests/urlpatterns_reverse/urlconf_inner.py
+++ b/tests/regressiontests/urlpatterns_reverse/urlconf_inner.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url
 from django.template import Template, Context
 from django.http import HttpResponse
 
diff --git a/tests/regressiontests/urlpatterns_reverse/urlconf_outer.py b/tests/regressiontests/urlpatterns_reverse/urlconf_outer.py
index 506e036..5d19cab 100644
--- a/tests/regressiontests/urlpatterns_reverse/urlconf_outer.py
+++ b/tests/regressiontests/urlpatterns_reverse/urlconf_outer.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url, include
 
 import urlconf_inner
 
diff --git a/tests/regressiontests/urlpatterns_reverse/urls.py b/tests/regressiontests/urlpatterns_reverse/urls.py
index c603c02..ea75db7 100644
--- a/tests/regressiontests/urlpatterns_reverse/urls.py
+++ b/tests/regressiontests/urlpatterns_reverse/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url, include
 from views import empty_view, absolute_kwargs_view
 
 other_patterns = patterns('',
diff --git a/tests/regressiontests/utils/urls.py b/tests/regressiontests/utils/urls.py
index ba09d14..3d4cfe1 100644
--- a/tests/regressiontests/utils/urls.py
+++ b/tests/regressiontests/utils/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns
 
 import views
 
diff --git a/tests/regressiontests/views/urls.py b/tests/regressiontests/views/urls.py
index d1412cd..a1b80c1 100644
--- a/tests/regressiontests/views/urls.py
+++ b/tests/regressiontests/views/urls.py
@@ -1,7 +1,7 @@
 # coding: utf-8
 from os import path
 
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url, include
 
 from models import *
 import views
diff --git a/tests/urls.py b/tests/urls.py
index 01d6408..c042b6b 100644
--- a/tests/urls.py
+++ b/tests/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, include
 
 urlpatterns = patterns('',
     # test_client modeltest urls