diff --git a/docs/ref/contrib/admin/index.txt b/docs/ref/contrib/admin/index.txt
index ac517e8..e6e5d57 100644
--- a/docs/ref/contrib/admin/index.txt
+++ b/docs/ref/contrib/admin/index.txt
@@ -1472,7 +1472,7 @@ In this example, we register the default ``AdminSite`` instance
 ``django.contrib.admin.site`` at the URL ``/admin/`` ::
 
     # urls.py
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
     from django.contrib import admin
 
     admin.autodiscover()
@@ -1488,7 +1488,7 @@ In this example, we register the ``AdminSite`` instance
 ``myproject.admin.admin_site`` at the URL ``/myadmin/`` ::
 
     # urls.py
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
     from myproject.admin import admin_site
 
     urlpatterns = patterns('',
@@ -1516,7 +1516,7 @@ separate versions of the admin site -- using the ``AdminSite`` instances
 respectively::
 
     # urls.py
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
     from myproject.admin import basic_site, advanced_site
 
     urlpatterns = patterns('',
diff --git a/docs/ref/contrib/comments/example.txt b/docs/ref/contrib/comments/example.txt
index 424bdb1..98094c8 100644
--- a/docs/ref/contrib/comments/example.txt
+++ b/docs/ref/contrib/comments/example.txt
@@ -140,7 +140,7 @@ enable it in your project's ``urls.py``:
 
 .. code-block:: python
 
-  from django.conf.urls.defaults import *
+  from django.conf.urls.defaults import patterns, url, include
   from django.contrib.comments.feeds import LatestCommentFeed
 
   feeds = {
diff --git a/docs/ref/contrib/formtools/form-wizard.txt b/docs/ref/contrib/formtools/form-wizard.txt
index 370fbdc..e42c648 100644
--- a/docs/ref/contrib/formtools/form-wizard.txt
+++ b/docs/ref/contrib/formtools/form-wizard.txt
@@ -192,7 +192,7 @@ deploy the new :class:`FormWizard` object a URL in ``urls.py``. The
 wizard takes a list of your :class:`~django.forms.Form` objects as
 arguments when you instantiate the Wizard::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
     from testapp.forms import ContactForm1, ContactForm2, ContactWizard
 
     urlpatterns = patterns('',
diff --git a/docs/ref/contrib/gis/tutorial.txt b/docs/ref/contrib/gis/tutorial.txt
index 9deeb78..4c1f8df 100644
--- a/docs/ref/contrib/gis/tutorial.txt
+++ b/docs/ref/contrib/gis/tutorial.txt
@@ -702,7 +702,7 @@ Let's dive in again -- create a file called ``admin.py`` inside the
 Next, edit your ``urls.py`` in the ``geodjango`` project folder to look
 as follows::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
     from django.contrib.gis import admin
 
     admin.autodiscover()
diff --git a/docs/ref/contrib/sitemaps.txt b/docs/ref/contrib/sitemaps.txt
index b58b55c..74cfbf9 100644
--- a/docs/ref/contrib/sitemaps.txt
+++ b/docs/ref/contrib/sitemaps.txt
@@ -241,7 +241,7 @@ Example
 
 Here's an example of a :doc:`URLconf </topics/http/urls>` using both::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
     from django.contrib.sitemaps import FlatPageSitemap, GenericSitemap
     from blog.models import Entry
 
diff --git a/docs/ref/contrib/syndication.txt b/docs/ref/contrib/syndication.txt
index 04f14b5..5400346 100644
--- a/docs/ref/contrib/syndication.txt
+++ b/docs/ref/contrib/syndication.txt
@@ -80,7 +80,7 @@ latest five news items::
 To connect a URL to this feed, put an instance of the Feed object in
 your :doc:`URLconf </topics/http/urls>`. For example::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
     from myproject.feeds import LatestEntriesFeed
 
     urlpatterns = patterns('',
@@ -327,7 +327,7 @@ Here's a full example::
 
 And the accompanying URLconf::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
     from myproject.feeds import RssSiteNewsFeed, AtomSiteNewsFeed
 
     urlpatterns = patterns('',
diff --git a/docs/ref/models/instances.txt b/docs/ref/models/instances.txt
index 88fd4e1..7fbccf5 100644
--- a/docs/ref/models/instances.txt
+++ b/docs/ref/models/instances.txt
@@ -506,7 +506,7 @@ reference the name rather than the view function. A named URL
 pattern is defined by replacing the pattern tuple by a call to
 the ``url`` function)::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
 
     url(r'^people/(\d+)/$',
         'django.views.generic.list_detail.object_detail',