diff --git a/django/contrib/admindocs/urls.py b/django/contrib/admindocs/urls.py
index 57edb56..2e9600f 100644
--- a/django/contrib/admindocs/urls.py
+++ b/django/contrib/admindocs/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url
 from django.contrib.admindocs import views
 
 urlpatterns = patterns('',
diff --git a/django/contrib/auth/urls.py b/django/contrib/auth/urls.py
index 4f8a102..c7b2d56 100644
--- a/django/contrib/auth/urls.py
+++ b/django/contrib/auth/urls.py
@@ -2,7 +2,7 @@
 # provided as a convenience to those who want to deploy these URLs elsewhere.
 # This file is also used to provide a reliable view deployment for test purposes.
 
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns
 
 urlpatterns = patterns('',
     (r'^login/$', 'django.contrib.auth.views.login'),
diff --git a/django/contrib/comments/urls.py b/django/contrib/comments/urls.py
index d903779..d3c06e5 100644
--- a/django/contrib/comments/urls.py
+++ b/django/contrib/comments/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, url
 
 urlpatterns = patterns('django.contrib.comments.views',
     url(r'^post/$',          'comments.post_comment',       name='comments-post-comment'),
diff --git a/django/contrib/databrowse/urls.py b/django/contrib/databrowse/urls.py
index 9b85d14..2559686 100644
--- a/django/contrib/databrowse/urls.py
+++ b/django/contrib/databrowse/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns
 from django.contrib.databrowse import views
 
 # Note: The views in this URLconf all require a 'models' argument,
diff --git a/django/contrib/flatpages/tests/urls.py b/django/contrib/flatpages/tests/urls.py
index 3cffd09..20cbc37 100644
--- a/django/contrib/flatpages/tests/urls.py
+++ b/django/contrib/flatpages/tests/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, include
 
 # special urls for flatpage test cases
 urlpatterns = patterns('',
diff --git a/django/contrib/flatpages/urls.py b/django/contrib/flatpages/urls.py
index 4928930..f6276df 100644
--- a/django/contrib/flatpages/urls.py
+++ b/django/contrib/flatpages/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns
 
 urlpatterns = patterns('django.contrib.flatpages.views',
     (r'^(?P<url>.*)$', 'flatpage'),
diff --git a/django/contrib/formtools/tests/urls.py b/django/contrib/formtools/tests/urls.py
index b89b6e6..c3351ed 100644
--- a/django/contrib/formtools/tests/urls.py
+++ b/django/contrib/formtools/tests/urls.py
@@ -2,7 +2,7 @@
 This is a URLconf to be loaded by tests.py. Add any URLs needed for tests only.
 """
 
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns
 from django.contrib.formtools.tests import *
 
 urlpatterns = patterns('',
diff --git a/django/contrib/gis/tests/geoapp/urls.py b/django/contrib/gis/tests/geoapp/urls.py
index edaf280..e0917e6 100644
--- a/django/contrib/gis/tests/geoapp/urls.py
+++ b/django/contrib/gis/tests/geoapp/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns
 from feeds import feed_dict
 
 urlpatterns = patterns('',
diff --git a/django/contrib/gis/tests/urls.py b/django/contrib/gis/tests/urls.py
index 95e36c2..ed49873 100644
--- a/django/contrib/gis/tests/urls.py
+++ b/django/contrib/gis/tests/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns, include
 
 urlpatterns = patterns('',
                        (r'^geoapp/', include('django.contrib.gis.tests.geoapp.urls')),
diff --git a/django/contrib/messages/tests/urls.py b/django/contrib/messages/tests/urls.py
index 6252adc..51f8816 100644
--- a/django/contrib/messages/tests/urls.py
+++ b/django/contrib/messages/tests/urls.py
@@ -1,4 +1,4 @@
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns
 from django.contrib import messages
 from django.core.urlresolvers import reverse
 from django.http import HttpResponseRedirect, HttpResponse
diff --git a/django/contrib/sitemaps/tests/urls.py b/django/contrib/sitemaps/tests/urls.py
index 6cdba36..6deb8cd 100644
--- a/django/contrib/sitemaps/tests/urls.py
+++ b/django/contrib/sitemaps/tests/urls.py
@@ -1,5 +1,5 @@
 from datetime import datetime
-from django.conf.urls.defaults import *
+from django.conf.urls.defaults import patterns
 from django.contrib.sitemaps import Sitemap, GenericSitemap, FlatPageSitemap
 from django.contrib.auth.models import User
 