diff --git a/docs/intro/overview.txt b/docs/intro/overview.txt
index 34572a6..5b02f62 100644
--- a/docs/intro/overview.txt
+++ b/docs/intro/overview.txt
@@ -176,7 +176,7 @@ decouple URLs from Python code.
 Here's what a URLconf might look like for the ``Reporter``/``Article``
 example above::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include    
 
     urlpatterns = patterns('',
         (r'^articles/(\d{4})/$', 'news.views.year_archive'),
diff --git a/docs/intro/tutorial02.txt b/docs/intro/tutorial02.txt
index c80d87d..d5f8728 100644
--- a/docs/intro/tutorial02.txt
+++ b/docs/intro/tutorial02.txt
@@ -43,7 +43,7 @@ activate the admin site for your installation, do these three things:
 
       .. parsed-literal::
 
-          from django.conf.urls.defaults import *
+          from django.conf.urls.defaults import patterns, url, include
 
           # Uncomment the next two lines to enable the admin:
           **from django.contrib import admin**
diff --git a/docs/intro/tutorial03.txt b/docs/intro/tutorial03.txt
index 0843d9e..ce7e2ca 100644
--- a/docs/intro/tutorial03.txt
+++ b/docs/intro/tutorial03.txt
@@ -78,7 +78,7 @@ point at that file::
 
 Time for an example. Edit ``mysite/urls.py`` so it looks like this::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
 
     from django.contrib import admin
     admin.autodiscover()
@@ -366,7 +366,7 @@ It's just a normal view.
 You normally won't have to bother with writing 404 views. By default, URLconfs
 have the following line up top::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
 
 That takes care of setting ``handler404`` in the current module. As you can see
 in ``django/conf/urls/defaults.py``, ``handler404`` is set to
@@ -459,7 +459,7 @@ callback in your URLconf, you can concatenate multiple
 :func:`~django.conf.urls.defaults.patterns`. Your full ``mysite/urls.py`` might
 now look like this::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
 
     from django.contrib import admin
     admin.autodiscover()
@@ -496,7 +496,7 @@ Copy the file ``mysite/urls.py`` to ``polls/urls.py``. Then, change
 :func:`~django.conf.urls.defaults.include`, leaving you with::
 
     # This also imports the include function
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
     
     from django.contrib import admin
     admin.autodiscover()
@@ -526,7 +526,7 @@ URLconf by removing the leading "polls/" from each line, and removing the
 lines registering the admin site. Your ``polls.urls`` file should now look like
 this::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
 
     urlpatterns = patterns('polls.views',
         (r'^$', 'index'),
diff --git a/docs/intro/tutorial04.txt b/docs/intro/tutorial04.txt
index 606da56..f036464 100644
--- a/docs/intro/tutorial04.txt
+++ b/docs/intro/tutorial04.txt
@@ -220,7 +220,7 @@ Read on for details.
 First, open the ``polls/urls.py`` URLconf. It looks like this, according to the
 tutorial so far::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
 
     urlpatterns = patterns('polls.views',
         (r'^$', 'index'),
@@ -231,7 +231,7 @@ tutorial so far::
 
 Change it like so::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
     from django.views.generic import DetailView, ListView
     from polls.models import Poll
 
diff --git a/docs/topics/class-based-views.txt b/docs/topics/class-based-views.txt
index f0e4910..5c7f8d3 100644
--- a/docs/topics/class-based-views.txt
+++ b/docs/topics/class-based-views.txt
@@ -75,7 +75,7 @@ views themselves are classes, we point the URL to the as_view class method
 instead, which is the entrypoint for class-based views::
 
     # urls.py
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
     from some_app.views import AboutView
 
     urlpatterns = patterns('',
@@ -86,7 +86,7 @@ Alternatively, if you're only changing a few simple attributes on a
 class-based view, you can simply pass the new attributes into the as_view
 method call itself::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
     from django.views.generic import TemplateView
 
     urlpatterns = patterns('',
@@ -135,7 +135,7 @@ be using these models::
 
 To build a list page of all publishers, we'd use a URLconf along these lines::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
     from django.views.generic import ListView
     from books.models import Publisher
 
diff --git a/docs/topics/generic-views.txt b/docs/topics/generic-views.txt
index 41e32c8..e24bb84 100644
--- a/docs/topics/generic-views.txt
+++ b/docs/topics/generic-views.txt
@@ -48,7 +48,7 @@ URLconf tuple for a given pattern.
 For example, here's a simple URLconf you could use to present a static "about"
 page::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
     from django.views.generic.simple import direct_to_template
 
     urlpatterns = patterns('',
@@ -70,7 +70,7 @@ the URLconf to point to a view function:
 
 .. parsed-literal::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
     from django.views.generic.simple import direct_to_template
     **from books.views import about_pages**
 
@@ -150,7 +150,7 @@ be using these models::
 
 To build a list page of all publishers, we'd use a URLconf along these lines::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
     from django.views.generic import list_detail
     from books.models import Publisher
 
diff --git a/docs/topics/http/urls.txt b/docs/topics/http/urls.txt
index 6179c30..542ad79 100644
--- a/docs/topics/http/urls.txt
+++ b/docs/topics/http/urls.txt
@@ -59,7 +59,7 @@ Example
 
 Here's a sample URLconf::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
 
     urlpatterns = patterns('',
         (r'^articles/2003/$', 'news.views.special_case_2003'),
@@ -70,7 +70,7 @@ Here's a sample URLconf::
 
 Notes:
 
-    * ``from django.conf.urls.defaults import *`` makes the ``patterns()``
+    * ``from django.conf.urls.defaults import patterns, url, include`` makes the ``patterns()``
       function available.
 
     * To capture a value from the URL, just put parenthesis around it.
@@ -177,7 +177,7 @@ Syntax of the urlpatterns variable
 ``django.conf.urls.defaults.patterns()``. Always use ``patterns()`` to create
 the ``urlpatterns`` variable.
 
-Convention is to use ``from django.conf.urls.defaults import *`` at the top of
+Convention is to use ``from django.conf.urls.defaults import patterns, url, include`` at the top of
 your URLconf. This gives your module access to these objects:
 
 patterns
@@ -335,7 +335,7 @@ code duplication.
 
 Here's the example URLconf from the :doc:`Django overview </intro/overview>`::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
 
     urlpatterns = patterns('',
         (r'^articles/(\d{4})/$', 'news.views.year_archive'),
@@ -350,7 +350,7 @@ each view function.
 
 With this in mind, the above example can be written more concisely as::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
 
     urlpatterns = patterns('news.views',
         (r'^articles/(\d{4})/$', 'year_archive'),
@@ -371,7 +371,7 @@ Just add multiple ``patterns()`` objects together, like this:
 
 Old::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
 
     urlpatterns = patterns('',
         (r'^$', 'django.views.generic.date_based.archive_index'),
@@ -381,7 +381,7 @@ Old::
 
 New::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
 
     urlpatterns = patterns('django.views.generic.date_based',
         (r'^$', 'archive_index'),
@@ -401,7 +401,7 @@ essentially "roots" a set of URLs below other ones.
 For example, here's the URLconf for the `Django Web site`_ itself. It includes a
 number of other URLconfs::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
 
     urlpatterns = patterns('',
         (r'^weblog/',        include('django_website.apps.blog.urls.blog')),
@@ -421,7 +421,7 @@ Another possibility is to include additional URL patterns not by specifying the
 URLconf Python module defining them as the `include`_ argument but by using
 directly the pattern list as returned by `patterns`_ instead. For example::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
 
     extra_patterns = patterns('',
         url(r'reports/(?P<id>\d+)/$', 'credit.views.report', name='credit-reports'),
diff --git a/docs/topics/http/views.txt b/docs/topics/http/views.txt
index 399e6b6..92cc8fc 100644
--- a/docs/topics/http/views.txt
+++ b/docs/topics/http/views.txt
@@ -143,7 +143,7 @@ URLconf, like so::
 Behind the scenes, Django determines the 404 view by looking for ``handler404``.
 By default, URLconfs contain the following line::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
 
 That takes care of setting ``handler404`` in the current module. As you can see
 in ``django/conf/urls/defaults.py``, ``handler404`` is set to
@@ -191,7 +191,7 @@ URLconf, like so::
 Behind the scenes, Django determines the error view by looking for ``handler500``.
 By default, URLconfs contain the following line::
 
-    from django.conf.urls.defaults import *
+    from django.conf.urls.defaults import patterns, url, include
 
 That takes care of setting ``handler500`` in the current module. As you can see
 in ``django/conf/urls/defaults.py``, ``handler500`` is set to